def fn check_if_fiver% (square%,direction%)
rem this checks whether a continuous row of at least 5 squares was created
rem this check should be made:
rem   - each time a stone is moved
rem   - each time a stone is added
rem the square% param is the square just added/moved
rem check down /up
rem check left/right
rem check left up/right down
rem check right up/left down
rem if the direction paramater is given, only this direction is checked
rem the parameter is	1 -> up/down
rem			2 -> left/right
rem			4 -> left & up / right & down
rem			8 -> right & up / lzft & down
rem this returns 0 if no complete row, else the number of stones in row
local target%,strt%,stp%,my_dir%
  if not direction%
    my_dir%=15
  else
    my_dir%= direction%
  end if
  if my_dir% && 1
    target%=squares%(square%)		: rem type of stone
    if target%=allgood%:target%=-1
    strt%=check_up%			: rem how many same squares up
    stp%=check_down%			: rem same down
    if strt%+stp%+1>4
      del_vert
      ret 1+strt%+stp%			: rem oho, fiver reached!
    endif
  endif
  if my_dir% && 2
    target%=squares%(square%)		: rem type of stone
    if target%=allgood%:target%=-1
    strt%=check_left%			: rem how many same squares left
    stp%=check_right%			: rem same right
    if strt%+stp%+1>4
      del_hori
      ret 1+strt%+stp%			: rem oho, fiver reached!
    endif
  endif
  if my_dir% && 4
    target%=squares%(square%)		: rem type of stone
    if target%=allgood%:target%=-1
    strt%=check_left_up%		: rem how many same squares left , up
    stp%=check_right_down%		: rem same right, down
    if strt%+stp%+1>4
      del_left_diag
      ret 1+strt%+stp%			: rem oho, fiver reached!
    endif
  endif
  if my_dir% && 8
    target%=squares%(square%)		: rem type of stone
    if target%=allgood%:target%=-1
    strt%=check_right_up%		: rem how many same squares left , up
    stp%=check_left_down%		: rem same right, down
    if strt%+stp%+1>4
      del_right_diag
      ret 1+strt%+stp%			: rem oho, fiver reached!
    endif
  endif
  ret 0
end def check_if_fiver%
:
def fn check_up%
rem checks the current column, up
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
local lp%,found%,sq%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%-rows%			: rem next row up
    if sq%<1:return found%		: rem was in last row already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_up%
:
def fn check_down%
rem checks the current column, down
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
local lp%,found%,sq%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%+rows%			: rem next row up
    if sq%>stopsquare%:return found%	: rem twas in last row already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_down%
:
def fn check_left%
rem checks the current row,left
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
rem the column number mod rows% = 0 if overshoot
local lp%,found%,sq%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%-1				: rem next column left
    if (sq% mod rows%)=0:return found%	: rem was in last col already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_left%
:
def fn check_right%
rem checks the current row to the right
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
rem the column number mod rows% = 0 if overshoot
local lp%,found%,sq%,end%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%+1				: rem next col to the right
    if (sq% mod rows%)=1:return found%	: rem was in last col already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_right%
:
def fn check_right_up%
rem checks horizontal, up & right
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
rem the column number mod rows% = 0 if overshoot
local lp%,found%,sq%,end%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%+1-rows%			: rem next col to the right & row up
    if sq%<1:return found%		: rem twas in last row already
    if (sq% mod rows%)=1:return found%	: rem was in last col already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_right_up%
:
def fn check_left_down%
rem checks horizontal, up & right
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
rem the column number mod rows% = 0 if overshoot
local lp%,found%,sq%,end%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%-1+rows%			: rem next col to the right & row up
    if sq%<1:return found%		: rem was in last row already
    if (sq% mod rows%)=0:return found%	: rem was in last col already
    if sq%>stopsquare%:return found%
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_left_down%
:
def fn check_left_up%
rem checks horizontal, up & right
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
rem the column number mod rows% = 0 if overshoot
local lp%,found%,sq%,end%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%-1-rows%			: rem next col to the right & row up
    if sq%<1:return found%		: rem was in last row already
    if (sq% mod rows%)=0:return found%	: rem was in last col already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_left_up%
:
def fn check_right_down%
rem checks horizontal, up & right
rem returns the number of identical squares
rem square% and target% come from check_if_fiver
rem the column number mod rows% = 0 if overshoot
local lp%,found%,sq%,end%
  found%=0
  sq%=square%
  rep lp%
    sq%=sq%+1+rows%			: rem next col to the right & row up
    if sq%>stopsquare%:return found%	: rem twas in last row already
    if (sq% mod rows%)=1:return found%	: rem was in last col already
    if (squares%(sq%)= target%) or (squares%(sq%)=allgood%)
      found%=found%+1
    else
      return found%
    endif
  end rep lp%
end def check_right_down%
:
